﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Data.Common;
// 画 像 一 覧　　プログラム
public partial class gazou : System.Web.UI.Page
{
    string connectionString;
    // 呼び出し時のｕｒｌ引数として　下記　システム分類、キーｃｄ、更新者、更新メッセージ　の指定ができます。
    //         例えば、http://このサーバー名/GAZOU/gazou.aspx?bunrui=山&keycd=富士山&koushinsya=私です。&koushinmsg=山＿画像を更新します
    //         例えば、http://このサーバー名/GAZOU/gazou.aspx   引数無しの呼び出しも可能
    string bunrui;
    string keycd;
    string koushinsya;
    string koushinmsg;

    // ここのPage_Loadというのは、画面表示処理
    protected void Page_Load(object sender, EventArgs e)
    {
        this.Label3.Text = "";
        this.Label3.ForeColor = System.Drawing.Color.Empty;
        this.Label4.Text = "";
        this.Label4.ForeColor = System.Drawing.Color.Empty;

        if (!IsPostBack)
        // !IsPostBackとは、このプログラムを最初に呼び出した時の処理
        {
            GridView1.EmptyDataText = "";
            bunrui = "";
            keycd = "";
            koushinsya = "";
            koushinmsg = "";
            // ｕｒｌ引数にbunrui有るか(bunrui有るなら、keycd koushinsya koushinmsg も引数に有る前提)
            Boolean bunrui_ari = false;
            foreach (string p in Request.Params)
            {
                if (p == "bunrui")
                {
                    bunrui_ari = true;
                }
            }
            if (bunrui_ari == true)
            {
                if (Request.QueryString["bunrui"].Trim() != "")
                {
                    bunrui = Request.QueryString["bunrui"].ToString();
                    keycd = Request.QueryString["keycd"].ToString();
                    koushinsya = Request.QueryString["koushinsya"].ToString();
                    koushinmsg = Request.QueryString["koushinmsg"].ToString();
                    this.TextBox1.Text = bunrui;
                    this.TextBox2.Text = keycd;
                    this.TextBox1.ReadOnly = true;
                    this.HiddenField3.Value = keycd;
                    // 更新者、更新メッセージはｈｉｄｄｅｎフィールドにセットしておいて、画像更新リンク・クリックから「画像登録」のプログラムへ引き渡していく
                    this.HiddenField1.Value = koushinsya;
                    this.HiddenField2.Value = koushinmsg;
                }
                else
                {
                    this.Label3.Text = "呼び出し時、ｕｒｌ引数に「システム分類」bunrui=・・・の指定をしたら、・・・に何かを必らず指定して。";
                    this.Label3.ForeColor = System.Drawing.Color.Red;
                    gazoubutton.Visible = false;
                    return;
                }
            }
            else
            {
                // ｕｒｌ引数が無い(bunrui無い、keycd koushinsya koushinmsgも無い)とき、デフォルトの更新者、更新メッセージは以下になります
                koushinsya = "私です。";
                koushinmsg = "画像管理の画像一覧メニューからの更新";
                this.HiddenField1.Value = koushinsya;
                this.HiddenField2.Value = koushinmsg;
            }
        }
        else
        {
            GridView1.EmptyDataText = "登録画像はありません。";
            bunrui = this.TextBox1.Text;
            keycd = this.TextBox2.Text;
            // なんでかpageloadココでもチェックしないと　　　（ボタン・クリック・イベントと　ページ・ロードの　実行タイミング　？同時　ワカラン）
            //  keycd = this.TextBox2.Text; だけでは、TextBox2に入力した内容のままkeycdにセットされて、下のＳＱＬ　ｓｅｌｅｃｔへ行ってしまう？？
            if (this.HiddenField3.Value != "")
            {
                if ((this.TextBox2.Text + "                    ").Substring(0, this.HiddenField3.Value.Length) != this.HiddenField3.Value || this.TextBox2.Text.Trim() == "")
                {
                    keycd = this.HiddenField3.Value;
                }
            }
            koushinsya = this.HiddenField1.Value;
            koushinmsg = this.HiddenField2.Value;
        }

        // 画像ＧＡＺＯＵデータベースの画像管理gazou_kanriテーブルから、システム分類、キーｃｄに該当するレコードをＳＥＬＥＣＴ
        if (this.TextBox1.Text.Trim() != "")
        {
            string sql = "select bunrui, keycd, koushinymd, koushinhms, koushinsya, replace(koushinmsg, '\r\n', '<br>') as koushinmsg, koushinpwd, sansyouymd, sansyoucnt, sansyoupwd, motoinfo, contenttype, gazoubin, replace(comment, '\r\n', '<br>') as comment, bunrui+','+keycd as bunruikeycd, '" + koushinsya + "' as param_koushinsya, '" + koushinmsg + "' as param_koushinmsg from gazou..gazou_kanri";
            //  これ－－＞bunrui+','+keycd as bunruikeycd　は、Ｇｒｉｄの中のｉｍｇ　ｓｒｃのｕｒｌ引数が一つしか指定できないためにｓｑｌでちょっと生成
            string where = this.createWherePhrase();
            if (where.Length != 0)
            {
                sql = sql + " where " + where;
            }
            sql = sql + " order by bunrui, keycd ";
            this.SqlDataSource1.SelectCommand = sql;
            connect_string();
            this.SqlDataSource1.ConnectionString = connectionString;
            this.SqlDataSource1.ProviderName = "System.Data.SqlClient";

        }
        // ＧＲＩＤ表にＳＥＬＥＣＴされたレコードを反映
        this.GridView1.DataBind();
    }


    // 「検索」ボタンをクリックした時の処理
    protected void Button1_Click(object sender, EventArgs e)
    {
        
        this.Label4.Text = "";
        this.Label4.ForeColor = System.Drawing.Color.Empty;

        if (this.TextBox1.Text.Trim() == "")
        {
            this.Label4.Text = "検索時、「システム分類」には何か指定して下さい。";
            this.Label4.ForeColor = System.Drawing.Color.Red;
            return;
        }

        if (this.HiddenField3.Value != "")
        {
            if ((this.TextBox2.Text + "                    ").Substring(0, this.HiddenField3.Value.Length) != this.HiddenField3.Value || this.TextBox2.Text.Trim() == "")
            {
                this.Label4.Text = "キーCDを違えての検索は不可です。";
                this.Label4.ForeColor = System.Drawing.Color.Red;
                this.TextBox2.Text = this.HiddenField3.Value;
                return;
            }
        }

    }

    // ＳＥＬＥＣＴ文のＷＨＥＲＥ条件を生成
    private string createWherePhrase()
    {
        StringBuilder where = new StringBuilder();
        if (bunrui.Length != 0)
        {
            // like'{0}%の％とは、 検索の指定の「システム分類」の頭が一致するものは検索対象になる
            where.Append(string.Format(" bunrui like'{0}%'", bunrui));
        }
        if (keycd.Length != 0)
        {
            if(where.ToString().Length != 0)
                where.Append(" and ");
            // like'{0}%の％とは、 検索の指定の「キーｃｄ」の頭が一致するものは検索対象になる
            where.Append(string.Format(" keycd like'{0}%'", keycd));
        }
        return where.ToString();
    }


    // ＧＲＩＤ表のcommandボタンの選択をクリックしたときの処理－－＞ここから「画像登録」touroku.aspxをＷｉｎｄｏｗ．ｏｐｅｎ（する。
    protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
    {
        GridViewRow selRow = GridView1.SelectedRow;
        string bunrui = selRow.Cells[0].Text;
        string keycd  = selRow.Cells[1].Text;

        ClientScript.RegisterStartupScript(this.GetType(), "nanikanandemo", "<script type='text/javascript'>window.open('touroku.aspx?bunrui=" + bunrui.ToString() + "&keycd=" + keycd.ToString() + "&koushinsya=" + koushinsya.ToString() + "&koushinmsg=" + koushinmsg.ToString() + "&sansyouflg=0&openersw=1','ichirantouroku','top=0,left=0,width=680,height=500,scrollbars=yes,toolbar=no,location=no,directories=no,status=no');history.back(0);</script>");
    }


    // 画像ＧＡＺＯＵデータベースへの
    // コネクション・ストリングはｗｅｂ．ｃｏｎｆｉｇから設定を読み込んでセット
    //         画像ＧＡＺＯＵデータベースのサーバー名、データベース名＝GAZOU、データベースへの接続に必要なユーザー saとか　とパスワードなどが予めセットしてある
    private void connect_string()
    {
                // ！！！　OpenWebConfiguration("/GAZOU")　！！！　　
        System.Configuration.Configuration WebConfig =
                        System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration("/GAZOU");
        System.Configuration.ConnectionStringSettings connString;
        if (0 < WebConfig.ConnectionStrings.ConnectionStrings.Count)
        {
            connString =
                WebConfig.ConnectionStrings.ConnectionStrings["gazouConnectionString"];
            if (null != connString)
            {
                connectionString = connString.ToString();
            }
        }
    }


}
