﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.Common;

// 画像レコードの削除プログラム--->今20081226のところ使ってないプログラム
//    このプログラムはＨＴＴＰリクエストで呼び出して使う。
//                     ｕｒｌ引数は、bunrui=システム分類とkeycd=キーCD 
//                    ＨＴＴＰリクエストの結果は、
//                      sakujyo_kekka = "1"   ・・・・成功　一件deleted
//                      sakujyo_kekka = "0"   ・・・・削除しようとしたが元々そんなbunrui=システム分類とkeycd=キーCDのレコードは無かった
//                      sakujyo_kekka = "E"   ・・・・なんらかのせいで失敗
public partial class sakujyo_gazou : System.Web.UI.Page
{
    String yyyymmdd;
    String hhmmss;

    // コネクション・ストリングはｗｅｂ．ｃｏｎｆｉｇから
    string connectionString;

    // ｕｒｌ引数　bunruiとkeycd指定の　システム分類 、キーｃｄ 　のレコードを削除できたら、　1　を返す。　
    string sakujyo_kekka = "0";

    protected void Page_Load(object sender, EventArgs e)
    {
        yyyymmdd = string.Format("{0:yyyyMMdd}", DateTime.Today);
        hhmmss = string.Format("{0:HHmmss}", DateTime.Now);

        string bunrui;
        string keycd;

        // bunruiとkeycdとは別々の引数
        bunrui = Request.QueryString["bunrui"].ToString();
        keycd = Request.QueryString["keycd"].ToString();

        // ！！！　OpenWebConfiguration("/GAZOU")　！！！　　コネクション・ストリングはｗｅｂ．ｃｏｎｆｉｇから
        System.Configuration.Configuration WebConfig =
                        System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration("/GAZOU");
        System.Configuration.ConnectionStringSettings connString;
        if (0 < WebConfig.ConnectionStrings.ConnectionStrings.Count)
        {
            connString =
                WebConfig.ConnectionStrings.ConnectionStrings["gazouConnectionString"];
            if (null != connString)
            {
                connectionString = connString.ToString();
            }
        }
        DbProviderFactory factory = DbProviderFactories.GetFactory("System.Data.SqlClient");
        using (DbConnection connection = factory.CreateConnection())
        {
            connection.ConnectionString = connectionString;
            connection.Open();

            using (DbCommand command = factory.CreateCommand())
            {
                try
                {

                    command.Connection = connection;
                    // ｕｒｌ引数で指定されたシステム分類bunruiとキーCD keycd のレコードを一件ＤＥＬＥＴＥ
                    string sql = "delete from gazou..gazou_kanri where bunrui = @bunrui and keycd = @keycd ";
                    DbParameter param1 = command.CreateParameter();
                    param1.ParameterName = "@bunrui";
                    param1.Value = bunrui;
                    DbParameter param2 = command.CreateParameter();
                    param2.ParameterName = "@keycd";
                    param2.Value = keycd;
                    command.CommandText = sql;
                    command.Parameters.AddRange(new DbParameter[] { param1, param2 });

                    command.Transaction = connection.BeginTransaction();
                    int delcnt = command.ExecuteNonQuery();
                    command.Transaction.Commit();
                    if (delcnt > 0)
                    {
                        sakujyo_kekka = "1";
                    }
                    else
                    {
                        // 削除ＤＥＬＥＴＥしようとしたが、指定されたシステム分類とキーCDのレコードは無かった。
                        sakujyo_kekka = "0";
                    }

                    command.Dispose();
                    connection.Close();
                    connection.Dispose();


                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    // 削除ＤＥＬＥＴＥに失敗
                    sakujyo_kekka = "E";
                    System.Diagnostics.Debug.WriteLine(ex.Message);
                }
                catch (Exception ex)
                {
                    // 削除ＤＥＬＥＴＥに失敗
                    sakujyo_kekka = "E";
                    System.Diagnostics.Debug.WriteLine(ex.Message);
                }
                if (command != null) { command.Dispose(); }

            }

            if (connection != null) { connection.Close(); connection.Dispose(); }

        }


        Response.AddHeader("Content-Type", "text/html; charset=shift_jis");

        Response.Write(sakujyo_kekka);

        Response.End();
    }
}
