﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Data.Common;

public partial class Thumbnail : System.Web.UI.Page
{
    string connectionString;
    // 呼び出し時のｕｒｌ引数として　下記　システム分類、キーｃｄ、更新者、更新メッセージ　の指定ができます。
    //         例えば、http://このサーバー名/GAZOU/thumbnail.aspx?bunrui=山&keycd=富士山&koushinsya=私です。&koushinmsg=山＿画像を更新します
    //         例えば、http://このサーバー名/GAZOU/thumbnail.aspx   引数無しの呼び出しも可能
    string bunrui;
    string keycd;
    string koushinsya;
    string koushinmsg;

    protected void Page_Load(object sender, EventArgs e)
    {
        
        
        gazoubutton.Attributes["onclick"] = "HiddenField8.value='';";
        maee.Attributes["onclick"] = "HiddenField8.value='before';";
        saihyouji.Attributes["onclick"] = "HiddenField8.value='saihyouji';";
        tsugie.Attributes["onclick"] = "HiddenField8.value='after';";
        this.Label3.Text = "";
        this.Label3.ForeColor = System.Drawing.Color.Empty;
        this.Label4.Text = "";
        this.Label4.ForeColor = System.Drawing.Color.Empty;

        if (!IsPostBack)
        {

            bunrui = "";
            keycd = "";
            koushinsya = "";
            koushinmsg = "";
            // ｕｒｌ引数にbunrui有るか(bunrui有るなら、keycd koushinsya koushinmsg も引数に有る前提)
            Boolean bunrui_ari = false;
            foreach (string p in Request.Params)
            {
                if (p == "bunrui")
                {
                    bunrui_ari = true;
                }
            }
            if (bunrui_ari == true)
            {
                if (Request.QueryString["bunrui"].Trim() != "")
                {
                    bunrui = Request.QueryString["bunrui"].ToString();
                    keycd = Request.QueryString["keycd"].ToString();
                    koushinsya = Request.QueryString["koushinsya"].ToString();
                    koushinmsg = Request.QueryString["koushinmsg"].ToString();
                    this.TextBox1.Text = bunrui;
                    this.TextBox2.Text = keycd;
                    this.TextBox1.ReadOnly = true;
                    this.HiddenField3.Value = keycd;
                    // 更新者、更新メッセージはｈｉｄｄｅｎフィールドにセットしておいて、画像更新リンク・クリックから「画像登録」のプログラムへ引き渡していく
                    this.HiddenField1.Value = koushinsya;
                    this.HiddenField2.Value = koushinmsg;
                }
                else
                {
                    this.Label3.Text = "呼び出し時、ｕｒｌ引数に「システム分類」bunrui=・・・の指定をしたら、・・・に何かを必らず指定して。";
                    this.Label3.ForeColor = System.Drawing.Color.Red;
                    gazoubutton.Visible = false;
                    return;
                }
            }
            else
            {
                // ｕｒｌ引数が無い(bunrui無い、keycd koushinsya koushinmsgも無い)とき、デフォルトの更新者、更新メッセージは以下になります
                koushinsya = "私です。";
                koushinmsg = "画像管理の画像サムネイル・メニューからの更新";
                this.HiddenField1.Value = koushinsya;
                this.HiddenField2.Value = koushinmsg;
            }
            Table1.Enabled = false;
            Table1.Visible = false;

            tsugie.Enabled = false;
            tsugie.Visible = false;
            HiddenField4.Value = "0";
            maee.Enabled = false;
            maee.Visible = false;
            saihyouji.Enabled = false;
            saihyouji.Visible = false;
            HiddenField8.Value = "";
        }
        else
        {


            Table1.Enabled = true;
            Table1.Visible = true;
            int cellcnt=0;
            for (cellcnt = 0; cellcnt < 50; cellcnt++)
            {
                Table1.Rows[cellcnt / 10].Cells[cellcnt % 10].Text = "";
                Table1.Rows[cellcnt / 10].Cells[cellcnt % 10].BorderWidth = 0;
                Table1.Rows[cellcnt / 10].Cells[cellcnt % 10].Width = 0;
                Table1.Rows[cellcnt / 10].Cells[cellcnt % 10].Height = 0;
            }
            bunrui = TextBox1.Text;
            keycd = TextBox2.Text;
            koushinsya = this.HiddenField1.Value;
            koushinmsg = this.HiddenField2.Value;
            // 画像ＧＡＺＯＵデータベースの画像管理gazou_kanriテーブルから、システム分類、キーｃｄに該当するレコードをＳＥＬＥＣＴ
            if (this.TextBox1.Text.Trim() != "")
            {
                string sql = "select bunrui, keycd from gazou..gazou_kanri ";
                string where = this.createWherePhrase();
                if (where.Length != 0)
                {
                    sql = sql + " where " + where;
                }

                sql = sql + " order by bunrui, keycd ";
//                Response.Write(sql);

                connect_string();
                DbProviderFactory factory = DbProviderFactories.GetFactory("System.Data.SqlClient");
                using (DbConnection connection = factory.CreateConnection())
                {
                    connection.ConnectionString = connectionString;
                    connection.Open();
                    using (DbCommand command = factory.CreateCommand())
                    {
                        try
                        {
                            command.Connection = connection;
                            command.CommandText = sql;
                            DbDataReader reader = command.ExecuteReader();

                            int skipcnt = 0;
                            if (HiddenField8.Value == "after")
                            {
                                skipcnt = int.Parse(HiddenField4.Value) + 50;  
                            }
                            if (HiddenField8.Value == "saihyouji")
                            {
                                skipcnt = int.Parse(HiddenField4.Value);
                            }
                            if (HiddenField8.Value == "before")
                            {
                                skipcnt = int.Parse(HiddenField4.Value) - 50;
                                if (skipcnt < 0) { skipcnt = 0; }
                            }

                            int kensu;
                            for (kensu = 0;kensu < skipcnt; kensu++)
                            {
                                if (reader.Read() == false)
                                {
                                    cellcnt = 51;
                                }
                            }

                            for(cellcnt=0;cellcnt<50;cellcnt++) 
                            {
                                if (reader.Read() == true)
                                {
                                    kensu++;
                                    Table1.Rows[cellcnt / 10].Cells[cellcnt % 10].Text = "<div style='width:90' align='center' onclick=javascript:window.open('touroku.aspx?bunrui=" + reader["bunrui"].ToString() + "&keycd=" + reader["keycd"].ToString() + "&koushinsya=" + koushinsya.ToString() + "&koushinmsg=" + koushinmsg.ToString() + "&sansyouflg=0&openersw=1','thumbnailtouroku','top=0,left=0,width=680,height=500,scrollbars=yes,toolbar=no,location=no,directories=no,status=no');><img src='gazou_out.aspx?bunrui=" + reader["bunrui"].ToString() + "&keycd=" + reader["keycd"].ToString() + "&sansyouflg=0' name=imagetab id=imageid alt='" + "システム分類=" + reader["bunrui"].ToString() + "　　キーCD=" + reader["keycd"].ToString() + "'></img></div>";
                                    Table1.Rows[cellcnt / 10].Cells[cellcnt % 10].BorderWidth = 1;
                                    Table1.Rows[cellcnt / 10].Cells[cellcnt % 10].Width = 90;
                                    Table1.Rows[cellcnt / 10].Cells[cellcnt % 10].Height = 90;
                                }
                                else
                                {
                                    cellcnt = 51;
                                }
                            }

                            HiddenField4.Value = skipcnt.ToString();

                            if (cellcnt == 50 && reader.Read() == true)
                            {
                                tsugie.Enabled = true;
                                tsugie.Visible = true;                               
                            }
                            else
                            {
                                tsugie.Enabled = false;
                                tsugie.Visible = false;
                            }
                            if (kensu < 51)
                            {
                                maee.Enabled = false;
                                maee.Visible = false;
                            }
                            else
                            {
                                maee.Enabled = true;
                                maee.Visible = true;
                            }
                            if (kensu > 0)
                            {
                                saihyouji.Enabled = true;
                                saihyouji.Visible = true;
                            }
                            else
                            {
                                saihyouji.Enabled = false;
                                saihyouji.Visible = false;
                            }
 
                            command.Dispose();
                            connection.Close();
                            connection.Dispose();                      
                        }
                        catch (System.Data.SqlClient.SqlException ex)
                        {
                            Response.Write(ex.Message);
                        }
                        catch (Exception ex)
                        {
                            Response.Write(ex.Message);
                        }
                        if (command != null) { command.Dispose(); }

                    }
                    if (connection != null) { connection.Close(); connection.Dispose(); }
                }
            }
        }

    }


    // ＳＥＬＥＣＴ文のＷＨＥＲＥ条件を生成
    private string createWherePhrase()
    {
        StringBuilder where = new StringBuilder();
        if (bunrui.Length != 0)
        {
            // like'{0}%の％とは、 検索の指定の「システム分類」の頭が一致するものは検索対象になる
            where.Append(string.Format(" bunrui like '{0}%'", bunrui));
        }
        if (keycd.Length != 0)
        {
            if (where.ToString().Length != 0)
                where.Append(" and ");
            // like'{0}%の％とは、 検索の指定の「キーｃｄ」の頭が一致するものは検索対象になる
            where.Append(string.Format(" keycd like '{0}%'", keycd));
        }
        return where.ToString();
    }
    // 画像ＧＡＺＯＵデータベースへの
    // コネクション・ストリングはｗｅｂ．ｃｏｎｆｉｇから設定を読み込んでセット
    //         画像ＧＡＺＯＵデータベースのサーバー名、データベース名＝GAZOU、データベースへの接続に必要なユーザー saとか　とパスワードなどが予めセットしてある
    private void connect_string()
    {
        // ！！！　OpenWebConfiguration("/GAZOU")　！！！　　
        System.Configuration.Configuration WebConfig =
                        System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration("/GAZOU");
        System.Configuration.ConnectionStringSettings connString;
        if (0 < WebConfig.ConnectionStrings.ConnectionStrings.Count)
        {
            connString =
                WebConfig.ConnectionStrings.ConnectionStrings["gazouConnectionString"];
            if (null != connString)
            {
                connectionString = connString.ToString();
            }
        }
    }



}
